diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-psdu.cc ns-3.31/src/wifi/model/wifi-psdu.cc
--- ns-3.30.1/src/wifi/model/wifi-psdu.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-psdu.cc	2020-06-27 17:38:30.000000000 -0700
@@ -20,10 +20,10 @@
 
 #include "ns3/packet.h"
 #include "ns3/log.h"
-#include "wifi-mac-queue-item.h"
 #include "wifi-psdu.h"
 #include "wifi-mac-trailer.h"
 #include "mpdu-aggregator.h"
+#include "ampdu-subframe-header.h"
 #include "wifi-utils.h"
 
 namespace ns3 {
@@ -74,23 +74,19 @@
 bool
 WifiPsdu::IsSingle (void) const
 {
-  NS_LOG_FUNCTION (this);
   return m_isSingle;
 }
 
 bool
 WifiPsdu::IsAggregate (void) const
 {
-  NS_LOG_FUNCTION (this);
   return (m_mpduList.size () > 1 || m_isSingle);
 }
 
 Ptr<const Packet>
 WifiPsdu::GetPacket (void) const
 {
-  NS_LOG_FUNCTION (this);
   Ptr<Packet> packet = Create<Packet> ();
-
   if (m_mpduList.size () == 1 && !m_isSingle)
     {
       packet = m_mpduList.at (0)->GetPacket ()->Copy ();
@@ -114,9 +110,7 @@
 Mac48Address
 WifiPsdu::GetAddr1 (void) const
 {
-  NS_LOG_FUNCTION (this);
   Mac48Address ra = m_mpduList.at (0)->GetHeader ().GetAddr1 ();
-
   // check that the other MPDUs have the same RA
   for (std::size_t i = 1; i < m_mpduList.size (); i++)
     {
@@ -131,9 +125,7 @@
 Mac48Address
 WifiPsdu::GetAddr2 (void) const
 {
-  NS_LOG_FUNCTION (this);
   Mac48Address ta = m_mpduList.at (0)->GetHeader ().GetAddr2 ();
-
   // check that the other MPDUs have the same TA
   for (std::size_t i = 1; i < m_mpduList.size (); i++)
     {
@@ -148,9 +140,7 @@
 Time
 WifiPsdu::GetDuration (void) const
 {
-  NS_LOG_FUNCTION (this);
   Time duration = m_mpduList.at (0)->GetHeader ().GetDuration ();
-
   // check that the other MPDUs have the same Duration/ID
   for (std::size_t i = 1; i < m_mpduList.size (); i++)
     {
@@ -166,7 +156,6 @@
 WifiPsdu::SetDuration (Time duration)
 {
   NS_LOG_FUNCTION (this << duration);
-
   for (auto& mpdu : m_mpduList)
     {
       mpdu->GetHeader ().SetDuration (duration);
@@ -176,8 +165,6 @@
 std::set<uint8_t>
 WifiPsdu::GetTids (void) const
 {
-  NS_LOG_FUNCTION (this);
-
   std::set<uint8_t> s;
   for (auto& mpdu : m_mpduList)
     {
@@ -227,7 +214,6 @@
 WifiPsdu::SetAckPolicyForTid (uint8_t tid, WifiMacHeader::QosAckPolicy policy)
 {
   NS_LOG_FUNCTION (this << +tid << policy);
-
   for (auto& mpdu : m_mpduList)
     {
       if (mpdu->GetHeader ().IsQosData () && mpdu->GetHeader ().GetQosTid () == tid)
@@ -237,74 +223,151 @@
     }
 }
 
+uint16_t
+WifiPsdu::GetMaxDistFromStartingSeq (uint16_t startingSeq) const
+{
+  NS_LOG_FUNCTION (this << startingSeq);
+
+  uint16_t maxDistFromStartingSeq = 0;
+  bool foundFirst = false;
+
+  for (auto& mpdu : m_mpduList)
+    {
+      uint16_t currSeqNum = mpdu->GetHeader ().GetSequenceNumber ();
+
+      if (mpdu->GetHeader ().IsQosData () && !QosUtilsIsOldPacket (startingSeq, currSeqNum))
+        {
+          uint16_t currDistToStartingSeq = (currSeqNum - startingSeq + SEQNO_SPACE_SIZE) % SEQNO_SPACE_SIZE;
+
+          if (!foundFirst || currDistToStartingSeq > maxDistFromStartingSeq)
+            {
+              foundFirst = true;
+              maxDistFromStartingSeq = currDistToStartingSeq;
+            }
+        }
+    }
+
+  if (!foundFirst)
+    {
+      NS_LOG_DEBUG ("All QoS Data frames in this PSDU are old frames");
+      return SEQNO_SPACE_SIZE;
+    }
+  NS_LOG_DEBUG ("Returning " << maxDistFromStartingSeq);
+  return maxDistFromStartingSeq;
+}
+
 uint32_t
 WifiPsdu::GetSize (void) const
 {
-  NS_LOG_FUNCTION (this);
   return m_size;
 }
 
 const WifiMacHeader &
 WifiPsdu::GetHeader (std::size_t i) const
 {
-  NS_LOG_FUNCTION (this << i);
   return m_mpduList.at (i)->GetHeader ();
 }
 
 WifiMacHeader &
 WifiPsdu::GetHeader (std::size_t i)
 {
-  NS_LOG_FUNCTION (this << i);
   return m_mpduList.at (i)->GetHeader ();
 }
 
 Ptr<const Packet>
 WifiPsdu::GetPayload (std::size_t i) const
 {
-  NS_LOG_FUNCTION (this << i);
   return m_mpduList.at (i)->GetPacket ();
 }
 
 Time
 WifiPsdu::GetTimeStamp (std::size_t i) const
 {
-  NS_LOG_FUNCTION (this << i);
   return m_mpduList.at (i)->GetTimeStamp ();
 }
 
+Ptr<Packet>
+WifiPsdu::GetAmpduSubframe (std::size_t i) const
+{
+  NS_ASSERT (i < m_mpduList.size ());
+  Ptr<Packet> subframe = m_mpduList.at (i)->GetProtocolDataUnit ();
+  subframe->AddHeader (MpduAggregator::GetAmpduSubframeHeader (static_cast<uint16_t> (subframe->GetSize ()),
+                                                               m_isSingle));
+  size_t padding = GetAmpduSubframeSize (i) - subframe->GetSize ();
+  if (padding > 0)
+    {
+      Ptr<Packet> pad = Create<Packet> (padding);
+      subframe->AddAtEnd (pad);
+    }
+  return subframe;
+}
+
+std::size_t
+WifiPsdu::GetAmpduSubframeSize (std::size_t i) const
+{
+  NS_ASSERT (i < m_mpduList.size ());
+  size_t subframeSize = 4; //A-MPDU Subframe header size
+  subframeSize += m_mpduList.at (i)->GetSize ();
+  if (i != m_mpduList.size () - 1) //add padding if not last
+    {
+      subframeSize += MpduAggregator::CalculatePadding (subframeSize);
+    }
+  return subframeSize;
+}
+
 std::size_t
 WifiPsdu::GetNMpdus (void) const
 {
-  NS_LOG_FUNCTION (this);
   return m_mpduList.size ();
 }
 
 std::vector<Ptr<WifiMacQueueItem>>::const_iterator
 WifiPsdu::begin (void) const
 {
-  NS_LOG_FUNCTION (this);
   return m_mpduList.begin ();
 }
 
 std::vector<Ptr<WifiMacQueueItem>>::iterator
 WifiPsdu::begin (void)
 {
-  NS_LOG_FUNCTION (this);
   return m_mpduList.begin ();
 }
 
 std::vector<Ptr<WifiMacQueueItem>>::const_iterator
 WifiPsdu::end (void) const
 {
-  NS_LOG_FUNCTION (this);
   return m_mpduList.end ();
 }
 
 std::vector<Ptr<WifiMacQueueItem>>::iterator
 WifiPsdu::end (void)
 {
-  NS_LOG_FUNCTION (this);
   return m_mpduList.end ();
 }
 
+void
+WifiPsdu::Print (std::ostream& os) const
+{
+  os << "size=" << m_size;
+  if (IsAggregate ())
+    {
+      os << ", A-MPDU of " << GetNMpdus () << " MPDUs";
+      for (const auto& mpdu : m_mpduList)
+        {
+          os << " (" << *mpdu << ")";
+        }
+      }
+  else
+    {
+      os << ", " << ((m_isSingle) ? "S-MPDU" : "normal MPDU")
+         << " (" << *(m_mpduList.at (0)) << ")";
+    }
+}
+
+std::ostream & operator << (std::ostream &os, const WifiPsdu &psdu)
+{
+  psdu.Print (os);
+  return os;
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-psdu.h ns-3.31/src/wifi/model/wifi-psdu.h
--- ns-3.30.1/src/wifi/model/wifi-psdu.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-psdu.h	2020-06-27 17:38:30.000000000 -0700
@@ -23,12 +23,12 @@
 
 #include "ns3/nstime.h"
 #include "wifi-mac-header.h"
+#include "wifi-mac-queue-item.h"
 #include <vector>
 #include <set>
 
 namespace ns3 {
 
-class WifiMacQueueItem;
 class Packet;
 
 /**
@@ -46,7 +46,7 @@
    * in an S-MPDU.
    *
    * \param p the payload of the MPDU.
-   * \param header the Wifi Mac header of the MPDU.
+   * \param header the Wifi MAC header of the MPDU.
    */
   WifiPsdu (Ptr<const Packet> p, const WifiMacHeader & header);
 
@@ -97,29 +97,46 @@
 
   /**
    * \brief Get the header of the i-th MPDU
+   * \param i index in the list of MPDUs
    * \return the header of the i-th MPDU.
    */
   const WifiMacHeader & GetHeader (std::size_t i) const;
 
   /**
    * \brief Get the header of the i-th MPDU
+   * \param i index in the list of MPDUs
    * \return the header of the i-th MPDU.
    */
   WifiMacHeader & GetHeader (std::size_t i);
 
   /**
    * \brief Get the payload of the i-th MPDU
+   * \param i index in the list of MPDUs
    * \return the payload of the i-th MPDU.
    */
   Ptr<const Packet> GetPayload (std::size_t i) const;
 
   /**
    * \brief Get the timestamp of the i-th MPDU
+   * \param i index in the list of MPDUs
    * \return the timestamp of the i-th MPDU.
    */
   Time GetTimeStamp (std::size_t i) const;
 
   /**
+   * \brief Get a copy of the i-th A-MPDU subframe (includes subframe header, MPDU, and possibly padding)
+   * \return the i-th A-MPDU subframe.
+   */
+  Ptr<Packet> GetAmpduSubframe (std::size_t i) const;
+
+  /**
+   * \brief Return the size of the i-th A-MPDU subframe.
+   *
+   * \return the size of the i-th A-MPDU subframe.
+   */
+  std::size_t GetAmpduSubframeSize (std::size_t i) const;
+
+  /**
    * Get the Receiver Address (RA), which is common to all the MPDUs
    * \return the Receiver Address.
    */
@@ -173,7 +190,19 @@
   void SetAckPolicyForTid (uint8_t tid, WifiMacHeader::QosAckPolicy policy);
 
   /**
-   * \brief Return the size of the PSDU
+   * Get the maximum distance between the sequence number of any QoS Data frame
+   * included in this PSDU that is not an old frame and the given starting
+   * sequence number. If this  PSDU does not contain any QoS Data frame that
+   * is not an old frame, an invalid distance (4096) is returned.
+   *
+   * \param startingSeq the given starting sequence number.
+   * \return the maximum distance between the sequence numbers included in the
+   *         PSDU and the given starting sequence number
+   */
+  uint16_t GetMaxDistFromStartingSeq (uint16_t startingSeq) const;
+
+  /**
+   * \brief Return the size of the PSDU in bytes
    *
    * \return the size of the PSDU.
    */
@@ -214,12 +243,27 @@
    */
   std::vector<Ptr<WifiMacQueueItem>>::iterator end (void);
 
+  /**
+   * \brief Print the PSDU contents.
+   * \param os output stream in which the data should be printed.
+   */
+  void Print (std::ostream &os) const;
+
 private:
   bool m_isSingle;                                //!< true for an S-MPDU
   std::vector<Ptr<WifiMacQueueItem>> m_mpduList;  //!< list of constituent MPDUs
-  uint32_t m_size;                                //!< the size of the PSDU
+  uint32_t m_size;                                //!< the size of the PSDU in bytes
 };
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param psdu the PSDU
+ * \returns a reference to the stream
+ */
+std::ostream& operator<< (std::ostream& os, const WifiPsdu &psdu);
+
 
 } //namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-radio-energy-model.cc ns-3.31/src/wifi/model/wifi-radio-energy-model.cc
--- ns-3.30.1/src/wifi/model/wifi-radio-energy-model.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-radio-energy-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -51,13 +51,13 @@
                                        &WifiRadioEnergyModel::GetCcaBusyCurrentA),
                    MakeDoubleChecker<double> ())
     .AddAttribute ("TxCurrentA",
-                   "The radio Tx current in Ampere.",
+                   "The radio TX current in Ampere.",
                    DoubleValue (0.380),    // transmit at 0dBm = 380mA
                    MakeDoubleAccessor (&WifiRadioEnergyModel::SetTxCurrentA,
                                        &WifiRadioEnergyModel::GetTxCurrentA),
                    MakeDoubleChecker<double> ())
     .AddAttribute ("RxCurrentA",
-                   "The radio Rx current in Ampere.",
+                   "The radio RX current in Ampere.",
                    DoubleValue (0.313),    // receive mode = 313mA
                    MakeDoubleAccessor (&WifiRadioEnergyModel::SetRxCurrentA,
                                        &WifiRadioEnergyModel::GetRxCurrentA),
@@ -74,7 +74,7 @@
                    MakeDoubleAccessor (&WifiRadioEnergyModel::SetSleepCurrentA,
                                        &WifiRadioEnergyModel::GetSleepCurrentA),
                    MakeDoubleChecker<double> ())
-    .AddAttribute ("TxCurrentModel", "A pointer to the attached tx current model.",
+    .AddAttribute ("TxCurrentModel", "A pointer to the attached TX current model.",
                    PointerValue (),
                    MakePointerAccessor (&WifiRadioEnergyModel::m_txCurrentModel),
                    MakePointerChecker<WifiTxCurrentModel> ())
@@ -97,7 +97,7 @@
   // set callback for WifiPhy listener
   m_listener = new WifiRadioEnergyModelPhyListener;
   m_listener->SetChangeStateCallback (MakeCallback (&DeviceEnergyModel::ChangeState, this));
-  // set callback for updating the tx current
+  // set callback for updating the TX current
   m_listener->SetUpdateTxCurrentCallback (MakeCallback (&WifiRadioEnergyModel::SetTxCurrentFromModel, this));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-radio-energy-model.h ns-3.31/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.30.1/src/wifi/model/wifi-radio-energy-model.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-radio-energy-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -43,7 +43,7 @@
 {
 public:
   /**
-   * Callback type for updating the transmit current based on the nominal tx power.
+   * Callback type for updating the transmit current based on the nominal TX power.
    */
   typedef Callback<void, double> UpdateTxCurrentCallback;
 
@@ -58,9 +58,9 @@
   void SetChangeStateCallback (DeviceEnergyModel::ChangeStateCallback callback);
 
   /**
-   * \brief Sets the update tx current callback.
+   * \brief Sets the update TX current callback.
    *
-   * \param callback Update tx current callback.
+   * \param callback Update TX current callback.
    */
   void SetUpdateTxCurrentCallback (UpdateTxCurrentCallback callback);
 
@@ -98,7 +98,7 @@
    * IDLE after TX duration.
    *
    * \param duration the expected transmission duration.
-   * \param txPowerDbm the nominal tx power in dBm
+   * \param txPowerDbm the nominal TX power in dBm
    *
    * Defined in ns3::WifiPhyListener
    */
@@ -152,8 +152,8 @@
   DeviceEnergyModel::ChangeStateCallback m_changeStateCallback;
 
   /**
-   * Callback used to update the tx current stored in WifiRadioEnergyModel based on
-   * the nominal tx power used to transmit the current frame.
+   * Callback used to update the TX current stored in WifiRadioEnergyModel based on
+   * the nominal TX power used to transmit the current frame.
    */
   UpdateTxCurrentCallback m_updateTxCurrentCallback;
 
@@ -207,7 +207,7 @@
  * \f$ I_{sleep} = 0.033 \f$
  *
  * The dependence of the power consumption in transmission mode on the nominal
- * transmit power can also be achieved through a wifi tx current model.
+ * transmit power can also be achieved through a wifi TX current model.
  *
  */
 class WifiRadioEnergyModel : public DeviceEnergyModel
@@ -241,7 +241,7 @@
   void SetEnergySource (const Ptr<EnergySource> source);
 
   /**
-   * \returns Total energy consumption of the wifi device.
+   * \returns Total energy consumption of the wifi device in watts.
    *
    * Implements DeviceEnergyModel::GetTotalEnergyConsumption.
    */
@@ -249,73 +249,73 @@
 
   // Setter & getters for state power consumption.
   /**
-   * \brief Gets idle current.
+   * \brief Gets idle current in Amperes.
    *
    * \returns idle current of the wifi device.
    */
   double GetIdleCurrentA (void) const;
   /**
-   * \brief Sets idle current.
+   * \brief Sets idle current in Amperes.
    *
    * \param idleCurrentA the idle current
    */
   void SetIdleCurrentA (double idleCurrentA);
   /**
-   * \brief Gets CCA busy current.
+   * \brief Gets CCA busy current in Amperes.
    *
    * \returns CCA Busy current of the wifi device.
    */
   double GetCcaBusyCurrentA (void) const;
   /**
-   * \brief Sets CCA busy current.
+   * \brief Sets CCA busy current in Amperes.
    *
    * \param ccaBusyCurrentA the CCA busy current
    */
   void SetCcaBusyCurrentA (double ccaBusyCurrentA);
   /**
-   * \brief Gets transmit current.
+   * \brief Gets transmit current in Amperes.
    *
    * \returns transmit current of the wifi device.
    */
   double GetTxCurrentA (void) const;
   /**
-   * \brief Sets transmit current.
+   * \brief Sets transmit current in Amperes.
    *
    * \param txCurrentA the transmit current
    */
   void SetTxCurrentA (double txCurrentA);
   /**
-   * \brief Gets receive current.
+   * \brief Gets receive current in Amperes.
    *
    * \returns receive current of the wifi device.
    */
   double GetRxCurrentA (void) const;
   /**
-   * \brief Sets receive current.
+   * \brief Sets receive current in Amperes.
    *
    * \param rxCurrentA the receive current
    */
   void SetRxCurrentA (double rxCurrentA);
   /**
-   * \brief Gets switching current.
+   * \brief Gets switching current in Amperes.
    *
    * \returns switching current of the wifi device.
    */
   double GetSwitchingCurrentA (void) const;
   /**
-   * \brief Sets switching current.
+   * \brief Sets switching current in Amperes.
    *
    * \param switchingCurrentA the switching current
    */
   void SetSwitchingCurrentA (double switchingCurrentA);
   /**
-   * \brief Gets sleep current.
+   * \brief Gets sleep current in Amperes.
    *
    * \returns sleep current of the wifi device.
    */
   double GetSleepCurrentA (void) const;
   /**
-   * \brief Sets sleep current.
+   * \brief Sets sleep current in Amperes.
    *
    * \param sleepCurrentA the sleep current
    */
@@ -341,15 +341,15 @@
   void SetEnergyRechargedCallback (WifiRadioEnergyRechargedCallback callback);
 
   /**
-   * \param model the model used to compute the wifi tx current.
+   * \param model the model used to compute the wifi TX current.
    */
   void SetTxCurrentModel (const Ptr<WifiTxCurrentModel> model);
 
   /**
-   * \brief Calls the CalcTxCurrent method of the tx current model to
-   *        compute the tx current based on such model
+   * \brief Calls the CalcTxCurrent method of the TX current model to
+   *        compute the TX current based on such model
    *
-   * \param txPowerDbm the nominal tx power in dBm
+   * \param txPowerDbm the nominal TX power in dBm
    */
   void SetTxCurrentFromModel (double txPowerDbm);
 
@@ -400,12 +400,13 @@
   void DoDispose (void);
 
   /**
-   * \returns draw of device, at given state.
+   * \param state the wifi state
+   * \returns draw of device in Amperes, at given state.
    */
   double GetStateA (int state) const;
 
   /**
-   * \returns Current draw of device, at current state.
+   * \returns Current draw of device in Amperes, at current state.
    *
    * Implements DeviceEnergyModel::GetCurrentA.
    */
@@ -422,15 +423,15 @@
   Ptr<EnergySource> m_source; ///< energy source
 
   // Member variables for current draw in different radio modes.
-  double m_txCurrentA; ///< transmit current
-  double m_rxCurrentA; ///< receive current
-  double m_idleCurrentA; ///< idle current
-  double m_ccaBusyCurrentA; ///< CCA busy current
-  double m_switchingCurrentA; ///< switching current
-  double m_sleepCurrentA; ///< sleep current
+  double m_txCurrentA; ///< transmit current in Amperes
+  double m_rxCurrentA; ///< receive current in Amperes
+  double m_idleCurrentA; ///< idle current in Amperes
+  double m_ccaBusyCurrentA; ///< CCA busy current in Amperes
+  double m_switchingCurrentA; ///< switching current in Amperes
+  double m_sleepCurrentA; ///< sleep current in Amperes
   Ptr<WifiTxCurrentModel> m_txCurrentModel; ///< current model
 
-  /// This variable keeps track of the total energy consumed by this model.
+  /// This variable keeps track of the total energy consumed by this model in watts.
   TracedValue<double> m_totalEnergyConsumption;
 
   // State variables.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-remote-station-info.h ns-3.31/src/wifi/model/wifi-remote-station-info.h
--- ns-3.30.1/src/wifi/model/wifi-remote-station-info.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-remote-station-info.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,7 +27,7 @@
 namespace ns3 {
 
 /**
- * \brief Tid independent remote station statistics
+ * \brief TID independent remote station statistics
  *
  * Structure is similar to struct sta_info in Linux kernel (see
  * net/mac80211/sta_info.h)
@@ -41,10 +41,12 @@
   /**
    * \brief Updates average frame error rate when data or RTS was transmitted successfully.
    *
-   * \param retryCounter is slrc or ssrc value at the moment of success transmission.
+   * \param retryCounter is SLRC or SSRC value at the moment of success transmission.
    */
   void NotifyTxSuccess (uint32_t retryCounter);
-  /// Updates average frame error rate when final data or RTS has failed.
+  /**
+   * Updates average frame error rate when final data or RTS has failed.
+   */
   void NotifyTxFailed ();
   /**
    * Return frame error rate (probability that frame is corrupted due to transmission error).
@@ -61,12 +63,10 @@
    * \return average coefficient for frame error rate
    */
   double CalculateAveragingCoefficient ();
-  /// averaging coefficient depends on the memory time
-  Time m_memoryTime;
-  /// when last update has occurred
-  Time m_lastUpdate;
-  /// moving percentage of failed frames
-  double m_failAvg;
+
+  Time m_memoryTime; ///< averaging coefficient depends on the memory time
+  Time m_lastUpdate; ///< when last update has occurred
+  double m_failAvg;  ///< moving percentage of failed frames
 };
 
 } //namespace ns3
